// APISampleView.cpp : implementation of the CAPISampleView class
//

#include "stdafx.h"
#include "APISample.h"

#include "APISampleDoc.h"
#include "APISampleView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView

IMPLEMENT_DYNCREATE(CAPISampleView, CView)

BEGIN_MESSAGE_MAP(CAPISampleView, CView)
	//{{AFX_MSG_MAP(CAPISampleView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView construction/destruction

CAPISampleView::CAPISampleView()
{
	// TODO: add construction code here

}

CAPISampleView::~CAPISampleView()
{
}

BOOL CAPISampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView drawing

void CAPISampleView::OnDraw(CDC* pDC)
{
	CAPISampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CFont normalFont;
	CPen tracePen(PS_SOLID, 2, RGB(192,0,0)); //Green, double thickness
	normalFont.CreatePointFont(140 ,"Arial",pDC);

	pDC->FillSolidRect(100,100,500,500,RGB(192,192,192));//Barely gray
	pDC->FillSolidRect(000,000,600,100,RGB(255,255,255));//White top

	double myAvg = 0.0;
	if(pDoc->bHaveValidPlot)
	{
		//First, get min and max
		int x;
		double maxamp=-180.0;
		double minamp=20.0;
		for(x=0; x<pDoc->sampleCount; x++)
		{
			double thispoint = pDoc->myData[x];
			if(maxamp < thispoint) maxamp = thispoint;
			if(minamp > thispoint) minamp = thispoint;
			myAvg += thispoint;
		}

		myAvg /= pDoc->sampleCount;

		//Now, plot.  Quick and easy.
		pDC->SelectObject(&tracePen);
		pDC->MoveTo(100,100.0 + 500.0 * (maxamp - pDoc->myData[0]) / (maxamp - minamp) ); //
		for(x=0; x<pDoc->sampleCount; x++)
		{
			double thisx = 100.0 + 500.0 * x / pDoc->sampleCount ;
			double thisy = 100.0 + 500.0 * (maxamp - pDoc->myData[x]) / (maxamp - minamp) ;
			pDC->LineTo(thisx,thisy); // Draw line to this point
		}

		//Graph title
		CString str;
		str.Format("Range: %.2f to %.2f dBm. Sweep: %.3f to %.3f MHz",minamp,maxamp,
			pDoc->startFreq * 1.0e-6,pDoc->stopFreq * 1.0e-6);
		pDC->TextOut(100,50,str);

		str.Format("RBW: %.0f Hz.  Displayed Avg Level: %.1f dBm",pDoc->myRBW, myAvg);
		pDC->TextOut(100,75,str);
	}

	DeleteObject(normalFont);
	DeleteObject(tracePen);
}

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView printing

BOOL CAPISampleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAPISampleView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CAPISampleView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView diagnostics

#ifdef _DEBUG
void CAPISampleView::AssertValid() const
{
	CView::AssertValid();
}

void CAPISampleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAPISampleDoc* CAPISampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAPISampleDoc)));
	return (CAPISampleDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAPISampleView message handlers
